<!-- Filter Expansion Panel -->
<mat-progress-bar *ngIf="handler.isLoadingResults" mode="indeterminate"></mat-progress-bar>
<mat-accordion>
  <mat-expansion-panel hideToggle
                       (opened)="handler.filterPanelOpen = true"
                       (closed)="handler.filterPanelOpen = false"
                       [expanded]="handler.filterPanelOpen"
  >
    <!-- Filter Expansion Panel (HEADER) -->
    <mat-expansion-panel-header>
      <mat-panel-title fxLayout="row" fxLayoutAlign="start center">
        <mat-icon>filter_list_alt</mat-icon>
        <h4>Filter</h4>
      </mat-panel-title>
    </mat-expansion-panel-header>
    <!-- END Filter Expansion Panel (HEADER) -->


    <!-- Filter form -->
    <form [formGroup]="tableManagerForm" (ngSubmit)="handleFilter()">
      <div class="content" fxLayout="row" fxLayout.xs="column" fxFlexFill>

        <!-- 1st Column Filter -->
        <div fxFlex="40" fxFlex.xs="55">
          <!-- Chips Input (arrays) -->
          <span *ngFor="let filterInput of multipleInputFilters.controls">
            <mat-form-field>
              <mat-chip-list #chipList>
                <mat-chip *ngFor="let element of filterInput.value.elements"
                          [selectable]="viewer.chipsConfig.selectable"
                          [removable]="viewer.chipsConfig.removable"
                          (removed)="handleRemoveChip(filterInput, element)"
                >
                  {{element}}
                  <mat-icon matChipRemove>cancel</mat-icon>
                </mat-chip>
                <input [placeholder]="filterInput.value.label"
                       [matChipInputFor]="chipList"
                       [matChipInputSeparatorKeyCodes]="viewer.chipsConfig.separatorKeysCodes"
                       [matChipInputAddOnBlur]="viewer.chipsConfig.addOnBlur"
                       (matChipInputTokenEnd)="handleAddChip(filterInput, $event)"
                       [matAutocomplete]="auto"
                >
              </mat-chip-list>

              <mat-autocomplete #auto="matAutocomplete" (optionSelected)="handleAddChip(filterInput, $event)">
                <mat-option *ngFor="let fruit of filterInput.value.autocompleteOptions" [value]="fruit">
                  {{fruit}}
                </mat-option>
              </mat-autocomplete>

            </mat-form-field>
          </span>
          <!-- END Chips Input (arrays) -->
        </div>
        <!-- END 1st Column Filter -->

        <!-- 2nd Column Filter -->
        <div fxFlex="30" fxFlex.lt-lg="100">

          <!-- birthDate -->
          <div fxLayout="row" fxLayout.lt-md="column">
            <div class="flex-item" fxFlex=50>
              <mat-form-field>
                <mat-label>birthDate &gt;= start date</mat-label>
                <input type="date" formControlName="birthDateStart" matInput>
              </mat-form-field>
            </div>
            <div class="flex-item" fxFlex=50>
              <mat-form-field>
                <mat-label>birthDate &lt; end date</mat-label>
                <input type="date" formControlName="birthDateEnd" matInput>
              </mat-form-field>
            </div>
          </div>

          <!-- birthDate -->
          <div fxLayout="row" fxLayout.lt-md="column">
            <div class="flex-item" fxFlex=50>
              <mat-form-field>
                <mat-label>issuingDate &gt;= start date</mat-label>
                <input type="date" formControlName="issuingDateStart" matInput>
              </mat-form-field>
            </div>
            <div class="flex-item" fxFlex=50>
              <mat-form-field>
                <mat-label>issuingDate &lt; end date</mat-label>
                <input type="date" formControlName="issuingDateEnd" matInput>
              </mat-form-field>
            </div>
          </div>

          <!-- Items per page -->
          <div fxLayout="row">
            <mat-form-field>
              <mat-label>Items per page</mat-label>
              <input type="number" formControlName="pageSize" min="1" matInput>
            </mat-form-field>
          </div>

          <!-- Select table columns -->
          <div fxLayout="row" fxLayoutGap="20px">

            <!-- Select table columns DEFAULT -->
            <div fxLayout="column">
              <strong>Default Columns: </strong>
              <div *ngFor="let checkBox of tableManagerDefaultColumns.controls; let i=index">
                <mat-checkbox [value]="checkBox.value.key"
                              color="primary"
                              (change)="handleDefaultColumnSelector($event, checkBox)"
                              [checked]="checkBox.value.visible"
                >
                  {{checkBox.value.label}}
                </mat-checkbox>
              </div>
            </div>

            <!-- Select table columns CUSTOM -->
            <div fxLayout="column">
              <strong>Custom columns: </strong>
              <div fxLayout="row" *ngFor="let checkBox of tableManagerCustomColumns.controls; let i=index">
                <mat-checkbox [value]="checkBox.value.key"
                              color="primary"
                              (change)="handleCustomColumnSelector($event, checkBox)"
                              [checked]="checkBox.value.visible"
                >
                  <div class="text-wrap">
                    {{checkBox.value.label}}
                  </div>
                </mat-checkbox>
              </div>
            </div>

          </div>
          <!-- END Select table columns -->

        </div>
        <!-- END 2nd Column Filter -->
      </div>

      <div fxLayout="row" fxLayoutAlign="end">
        <button mat-raised-button color="primary" type="submit">Search</button>
      </div>


    </form>
    <!-- END Filter form -->
  </mat-expansion-panel>
</mat-accordion>
<!-- END Filter Expansion Panel -->

<!-- Pagination div -->
<div class="container">
  <mat-paginator
    [pageSizeOptions]="viewer.pageSizeOptions"
    [showFirstLastButtons]="viewer.showFirstLastButtons"
    [length]="tableManager.itemsCount" 
    [pageSize]="tableManager.pageSize"
    [pageIndex]="tableManager.pageIndex"
    (page)="handlePageEvent($event)">
  </mat-paginator>
</div>
<!-- END Pagination div -->

<!-- Event Table div -->
<div class="scroll-container">
  <div class="table-loading-shade" *ngIf="handler.isLoadingResults"></div>

  <div class="table-rasponsive table-container">
    <!-- <div class="table-rasponsive"> </div> -->
    <table mat-table matSort
                 [dataSource]="dataSource"
                 (matSortChange)="handleSortData($event)"
                 [matSortActive]="this.tableManager.sortProperty"
                 [matSortDirection]="this.tableManager.sortDirection"
          >

      <!-- eGovPassport Id Column -->
      <ng-container matColumnDef="id" sticky>
        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{tableDataRetriever['id'].label}}</th>
        <td mat-cell *matCellDef="let element">
          <a routerLink="/egovpassport/{{element.id}}">
            {{tableDataRetriever['id'].data(element)}}
          </a>
        </td>
      </ng-container>

      <!-- givenName Column -->
      <ng-container matColumnDef="passportNumber">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{tableDataRetriever['passportNumber'].label}}</th>
        <td mat-cell *matCellDef="let element"> {{tableDataRetriever['passportNumber'].data(element)}} </td>
      </ng-container>

      <!-- givenName Column -->
      <ng-container matColumnDef="givenName">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{tableDataRetriever['givenName'].label}}</th>
        <td mat-cell *matCellDef="let element"> {{tableDataRetriever['givenName'].data(element)}} </td>
      </ng-container>

      <!-- surname Column -->
      <ng-container matColumnDef="surname">
        <th mat-header-cell *matHeaderCellDef mat-sort-header>{{tableDataRetriever['surname'].label}}</th>
        <td mat-cell *matCellDef="let element"> {{tableDataRetriever['surname'].data(element)}} </td>
      </ng-container>

      <!-- birthDate Column - is part of the CUSTOM columns -->
      <!-- ng-container matColumnDef="birthDate">
              <th mat-header-cell *matHeaderCellDef mat-sort-header>{{tableDataRetriever['birthDate'].label}}</th>
              <td mat-cell *matCellDef="let element"> {{tableDataRetriever['birthDate'].data(element)}} </td>
            </ng-container -->

      <!-- Selected Columns by CheckBox - CUSTOM -->
      <div fxLayout="row" fxLayoutGap="25px" class="center"
        *ngFor="let checkColumnSelected of this.tableManagerCustomColumns.controls">
        <ng-container [matColumnDef]="checkColumnSelected.value.key">
          <th mat-header-cell *matHeaderCellDef>
            {{ tableDataRetriever[checkColumnSelected.value.key].label }}
          </th>
          <td
            [ngClass]="tableDataRetriever[checkColumnSelected.value.key].cssClasses ? tableDataRetriever[checkColumnSelected.value.key].cssClasses(element) : ''"
            mat-cell *matCellDef="let element">
            {{tableDataRetriever[checkColumnSelected.value.key].data(element)}}
          </td>
        </ng-container>
      </div>

      <tr mat-header-row *matHeaderRowDef="handler.displayedColumns; sticky: true"></tr>
      <tr mat-row *matRowDef="let row; columns: handler.displayedColumns;"></tr>
    </table>

  </div>
</div>
<!-- END EGovPassport Table div -->

<div class="text-danger m-b-10" fxLayout="row" fxLayoutAlign="end center">
  <button mat-mini-fab matTooltip="ePassports" matTooltipPosition="left" color="primary" (click)="handleDownloadScans()">
    <mat-icon>cloud_download</mat-icon>
  </button>
</div>